#!/usr/bin/python

# 131.191.83.83


import netio
from Users import *
from UnitForm import *
from random import *
import MessageMap
import Timer

try:
    import psyco
    psyco.full()
except:
    pass


import Network  





class GalacticusServer(netio.Server):
   
    
    def logout(self,data):
    
       
       user = self.users.byIP(self.fromaddress)
       print user.name , "loged out"
       user.address = None
       #self.send("exit", True )
    
    def login(self,login):
   
            name = login[0]
            password = login[1]
           
            print "wanna log in" , name, password
        
           
            if self.users.passwordCheck(name, password,self.fromaddress ):
                
        
                
                self.send("msg", ["sys", name + " have loged in" ] );
                self.send("login", True )        
                print name + " loged in "
            else:
                self.send("msg", ["sys","name or password is incorect" ] );
                print name + " name or password is incorect "
            
    def pickSpot(self):
        
        gx,gy = gauss(0,10),gauss(0,10)
        gDist = 0
            
        
        for i in range(20):
            x = gauss(0,10)
            y = gauss(0,10)
           
            
        
            for unit in self.unitForm.units.values():
       
                Dist = ((x-unit.x)**2 + (y-unit.y)**2)**.5
                if Dist < gDist :
                    
                    if Dist > 9:
                        
                        gDist = Dist
                        gx = x
                        gy = y
                        
                    elif gDist < 9 and Dist > gDist :
                        
                        gDist = Dist
                        gx = x
                        gy = y
          
        return gx,gy
            
    def createnew(self,createnew):
            
            
            name = createnew[0]
            password = createnew[1]
           
            print "wanna create" , name, password
        
           
            if self.users.newUser(name, password, self.fromaddress ):
                
                x,y = self.pickSpot()
                
                self.send("msg", ["sys", name + " created "] )
                self.send("login", [x,y] )
                self.unitForm.newUnit( Wr(0,x,y, self.users.nameToID(name) )  )
         
            else:
                self.send("msg",["sys", name + " already exist pick a diferent one"] )
            
    def chat(self,data):
        
        name = self.users.ipToName(self.fromaddress)
        
        if data[0] == "all":
            self.sendall( "msg" , ["sys", "[" + str(name) + "]" + data[1] ] )
    
        print "[" + str(name) + "]" + data[1]
    
    def sendall(self, msg , data ):
        
        for user in self.users.u.values():
            if user.address != None:
             
             if not self.sendto(user.address, msg, data ):
                print "disconecting user" , user.name
                user.address = None
                
                
                
    def move(self,data):
        
        owner = self.users.ipToID(self.fromaddress)
       
        
        list = data[0]
        x,y  = data[1]
        
        print "moving" , list , "to", x,y
        
        
        for id in list:
          try:
            unit = self.unitForm.units[id]
         
            if unit.owner == owner:
                unit.gx = x
                unit.gy = y
          except KeyError:
              pass  
        
    def clone(self,data):
        
        return
        
        owner = self.users.ipToID(self.fromaddress)
             
        for id in data:
           try: 
            unit = self.unitForm.units[id]
            if unit.owner == owner:
            
                a = Ansestor(0,unit.x+random()-.5,unit.y+random()-.5, unit.owner )
                self.unitForm.newUnit( a ) 
           except KeyError:
              pass   
                
    def getunits(self,data):
      
        
        unitlist = self.unitForm.units.values()
        
        if self.unitForm.deadtime % 10 == 0 and self.unitForm.deadlist != [] :
            self.send("deadlist" , self.unitForm.deadlist )
            
            if self.unitForm.deadtime > 100:
                self.unitForm.deadlist == [] 
        
        self.unitForm.deadtime += 1
        
        if randint(0,10):
            user = self.users.byIP(self.fromaddress)
            if user != None:
                self.send("user", [user.name, user.steam ]   )
            
        
        self.send("getunits", sample(unitlist,20) )
            
            
    def build(self,data):
        
         
          
        type = data[0]
        list = data[1]
        
        if type == "wr" :
            self.Build(Wr,50,C1,list)
        
        elif type == "b1" :
            self.Build(B1,10,F1,list)
        
        elif type == "b2" :
            self.Build(B2,150,F1,list)
        
        elif type == "b3" :
            self.Build(B3,300,F2,list)
               
        elif type == "c1" :
            self.Build(C1,400,Wr,list)
        
        elif type == "c2" :
            self.Build(C2,800,Wr,list)
           
        elif type == "f1" :
            self.Build(F1,300,Wr,list)
        
        elif type == "f2" :
            self.Build(F2,800,Wr,list)
        
        elif type == "e1" :
            self.Build(E1,200,Wr,list)
        
        
    
    
    
    def Build(self,UnitType,cost,UnitNeeded,list):
        
       
        user = self.users.byIP(self.fromaddress)
        if user == None:
            print "user not found"
            return
      
        if user.steam < cost:
            self.send( "msg" , ["sys",  "You must have "+ str(cost)+ " steam" ] )
            return
        
        created = False
        
        for id in list:
          try:
            unit = self.unitForm.units[id]
         
            if unit.owner == user.id and unit.__class__ == UnitNeeded:
         
                user.steam -= cost
                newunit = UnitType(0,unit.x+random()-.5,unit.y+random()-.5, unit.owner )
                self.unitForm.newUnit( newunit ) 
                print "new unit " ,  newunit
                created = True
                  
          except KeyError:
              pass  
         
        if not created: 
            self.send( "msg" , ["sys",  "You must have "+ str(UnitNeeded.name)+ " selected" ] )
       
        
        
ip = Network.GetServerIP()           
#gs = GalacticusServer(('127.0.0.1',29999))   
#gs = GalacticusServer(('131.191.83.83',29999))   
gs = GalacticusServer((ip,29999), MessageMap.Map )   



gs.users = Users()
     
gs.unitForm = UnitForm()
for i in range(100):
    gs.unitForm.newUnit( Steam(0,gauss(0,10),gauss(0,10), -1, 2000 )  )        
     
     
#
#unitlist = gs.unitForm.units.values()
#print unitlist          
#pk =  gs.p.pack(unitlist) 
#print "**" , pk , "end"
#     
#print  gs.p.unpack(pk) 
        
globalTimer = Timer.Timer(.5)        
        
        
while True:
    if globalTimer.isTime():
        gs.unitForm.Do(globalTimer.sec)
        gs.unitForm.CollectSteam(globalTimer.sec,gs.users)
        #print gs.unitForm.units
    else :
        netio.sleep(.01)
    
    
    
    
    
    
#    if gs.badaddress != None:
#        user = gs.users.byIP(gs.badaddress)
#        if user != None:
#            user.address = None
#            
#        gs.badaddress = None
#           
#           
#execfile("C:\Documents and Settings\Administrator\workspace\Galacticus2\Galacticus.py")      
            
        
        
        
        
    