

from pyTriD import *


class Mouse:
    
    
    def __init__(self,TriD ):
        
        self.t = TriD
        self.m = Matrix()
        
        self.m.Edit()
        glTranslatef(0,0,-10)
        self.m.EndEdit();
        
        
        self.pos = (0,0,0)
        self.pointAt = (0,0,0)
        self.d = None
        self.tr = (0,0,0) 
       
    def Use(self):
    
        mx,my = self.t.mouse
        
        mx,my = [100,100]
        
        rec = self.t.rec
        keys = self.t.keys
        px,py,pz = self.tr  #self.pos 
        self.tr = (0,0,0)
        s = 1
        
        
        if mx < rec[0] + 15 or keys[GLUT_KEY_RIGHT]:
            px = -.1*s
        
        if mx > rec[2] - 15 or keys[GLUT_KEY_LEFT]:
            px = .1*s
         
        if my < rec[1] + 15 or keys[GLUT_KEY_DOWN]:
            py = .1*s
        
        if my > rec[3] - 15 or keys[GLUT_KEY_UP]:
            py = -.1*s 
        
        if keys[GLUT_KEY_PAGE_DOWN]:
            pz = -.10*s
            #if pz > -1: pz = -1
        
        if keys[GLUT_KEY_PAGE_UP]:
            pz = +.10*s

        rx,ry = [0,0]
        
        if keys[ GLUT_MIDDLE_BUTTON ] or keys[ 'o' ] :
            
            rx,ry = self.t.ChangeInMouse
            rx /= 10.
            ry /= 10.
            
           # print self.m.mx
        #self.Pos()
#        if keys['s']:
#            Camera.Begin()
#            glRotatef( -1, 1.0, 0.0, 0.0 )            # Rotate The Cube On It's X Axis
#            Camera.End()
#        if keys['w']:
#            Camera.Begin()
#            glRotatef(  1, 1.0, 0.0, 0.0 )            # Rotate The Cube On It's X Axis
#            Camera.End()
#        if keys['d']:
#            Camera.Begin()
#            glRotatef( -1, 0.0, 1.0, 0.0 )            # Rotate The Cube On It's X Axis
#            Camera.End()
#        if keys['a']:
#            Camera.Begin()
#            glRotatef( 1, 0.0, 1.0, 0.0 )            # Rotate The Cube On It's X Axis
#            Camera.End()
#          
           
        
        
        self.m.Edit()
        
        glRotatef( ry, 1.0, 0.0, 0.0 )
        glRotatef( rx, 0.0, 1.0, 0.0 )
       
        glTranslatef(px,py,pz)
        
        self.m.UseFast()
           
        self.m.EndEdit();
        
           #self.m.Use();

    def Pos(self):
        
        
        #if self.t.MouseFree and self.t.keys[GLUT_RIGHT_BUTTON]:
            
          
            V = Matrix()
            self.m.EditFast()
            
            #glRotatef( self.t.mouse[1]*500, 1.0, 0.0, 0.0 )            
            #glRotatef( -self.t.mouse[0]*500, 0.0, 1.0, 0.0 )            
            
            glTranslate(0,0, 1)
            
            V.EndEdit()
            
            A = self.m.Pos()
            C = A
            B = A-V.Pos()
            #B *= .1
            #A = Vec([mouse.x,mouse.y,0])
            #B = Vec([mouse.x,mouse.y,-.1])
            
            for a in range(1000):
                A = A + B
            
                if A.z  < 0:
                    #print A
                    
                    self.pos = [ A.x ,  A.y , A.z   ]       
                    return A
        
            self.pos = [ 0 ,  0 , 0   ] 
            return False  
        
    def goto(self,x,y):
#        
#        m = Matrix()
#        m.Edit()
#        glTranslatef(x,y,-10)
#        m.EndEdit();
#        
#        
#        self.m = m
        self.tr = (-x,-y,0)  
          
            
#            p = self.m.Pos()
#            
#            mt = Matrix(self.m.mx)
#            
#            mt.Edit()
#            glTranslatef(0,0,-1)
#            mt.UseFast()
#                        
#            mt.EndEdit();
#            
#            
#            d =  mt.Pos() - self.m.Pos() 
#            
#            print p,d
#            
#            # v = < p.x + d.x*t , p.y + d.y*t  , p.z + d.z*t  >
#            # when  v.y == 0
#            #     t = -p.y/d.y
#            
#            if  d.z != 0:
#            
#                t = -p.z/d.z
#                
#                self.pos = [ -p.x-d.x*t ,  -p.y-d.y*t ,  -p.z-d.z*t   ] 
#                
#                #self.pos 
#              
#                
#                
#            else:
#                self.pos = [ 0 ,  0 , 0   ] 
#                


    def SelectTile(self):
      
        mx,my = self.t.mouse
      
        x,y,fx,fy = 0,0,0,0
      
        self.d.SetUpSelectionBuffer([mx/2,my,mx/2+1,my+1])
        self.d.thrDrawBlocks()
        self.d.TaredownSelectionBuffer()
        self.selbuf =  glRenderMode(GL_RENDER);
      
        for i in self.selbuf:
            n = int(i[2][0])
      
            y = n % 1000
            x = n / 1000
            
            y -= 100
            x -= 100
        
        self.d.SetUpSelectionBuffer([mx/2,my,mx/2+1,my+1])
        self.d.thrDrawTiles(x,y)
        self.d.TaredownSelectionBuffer()
        self.selbuf =  glRenderMode(GL_RENDER);
        
        for i in self.selbuf:
            n = int(i[2][0])
            
            fy = n % 1000
            fx = n / 1000
      
        self.pos = (x+fx, y+fy,0 )
        
    def _oldSelectTile(self):
        
        
        
        mx,my = self.t.mouse
        
        
        
        self.d.SetUpSelectionBuffer([mx/2,my,mx/2+1,my+1])
        self.d.thrDrawBlocks()
        self.d.TaredownSelectionBuffer()
        self.selbuf =  glRenderMode(GL_RENDER);
        
        
        #print self.selbox
        #print self.selbuf 
        #print len(self.selbuf) 
         
        for i in self.selbuf:
            n = int(i[2][0])
         
            #(x+100)* 1000 + (y+100)  
            
            
            y = n % 1000
            x = n / 1000
            
            y -= 100
            x -= 100
            #print "XY" , x,y
        
        
        glColor3f(0.0, 0.0, 1.0)           
        glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
        glTexCoord2f(0.0, 0.0); glVertex3f(x, y,  0)    # Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(x+10, y,  0)    # Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(x+10, y+10,  0)    # Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(x, y+10,  0)    # Top Left Of The Texture and Quad
        glEnd() 
    
    
      
        self.d.SetUpSelectionBuffer([mx/2,my,mx/2+1,my+1])
        self.d.thrDrawTiles(x,y)
        self.d.TaredownSelectionBuffer()
        self.selbuf =  glRenderMode(GL_RENDER);
        
        #return
        #print self.selbox
       # print self.selbuf 
        #print len(self.selbuf) 
        fx = 0 
        fy = 0 
        for i in self.selbuf:
            n = int(i[2][0])
            
            fy = n % 1000
            fx = n / 1000
            
            #print "fxy", fx,fy

        glColor3f(1.0, 0.0, 0.0)            # Bluish shade
        glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
        glTexCoord2f(0.0, 0.0); glVertex3f(x+fx, y+fy,  .1)    # Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f(x+fx+1, y+fy,  .1)    # Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f(x+fx+1, y+fy+1,  .1)    # Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(x+fx, y+fy+1,  .1)    # Top Left Of The Texture and Quad
         
        glEnd()     
        glColor3f(0.0, 1.0, 0.0)   
        print "total" ,  x+fx, y+fy
        
        self.pos = (x+fx, y+fy,0 )
        
        
        
