   

from pyTriD import *   
        
class OptionBar:
    
    def __init__(self,selector,net,gui,sounds,y):    
      
        self.selector = selector
        self.net = net
        self.sounds = sounds
        self.frame = Panel( "Options",[0,y-64-100,64*10,64] )
              
        gui.Add(self.frame)
        
        self.n = 0
       
        self.AddOption( "wr" , self.makeWr )
        self.AddOption( "b1" , self.makeB1 )
        self.AddOption( "b2" , self.makeB2 )
        self.AddOption( "b3" , self.makeB3 )
        self.AddOption( "c1" , self.makeC1 )
        self.AddOption( "c2" , self.makeC2 )
        self.AddOption( "f1" , self.makeF1 )
        self.AddOption( "f2" , self.makeF2 )
        self.AddOption( "e1" , self.makeE1 )
        
        
       
    def Clear(self):
    
        self.n = 0
        self.frame.children = []
        
    def AddOption(self,picturename,fuctionname):
        
        self.frame.Add(IconButton("data/"+picturename+".png",picturename,fuctionname , [self.n,0,64,64]))
        self.n += 65
        
        
    def makeWr(self,button):
         self.net.send("build" , ["wr" ,self.selector.selobj ])    
   
    def makeB1(self,button):
         self.net.send("build" , ["b1" ,self.selector.selobj ])    
   
    def makeB2(self,button):
         self.net.send("build" , ["b2" ,self.selector.selobj ])    
   
    def makeB3(self,button):
         self.net.send("build" , ["b3" ,self.selector.selobj ])    
   
    def makeC1(self,button):
         self.net.send("build" , ["c1" ,self.selector.selobj ])    
   
    def makeC2(self,button):
         self.net.send("build" , ["c2" ,self.selector.selobj ])    
   
    def makeF1(self,button):
         self.net.send("build" , ["f1" ,self.selector.selobj ])    
    
    def makeF2(self,button):
         self.net.send("build" , ["f2" ,self.selector.selobj ])    
   
    def makeE1(self,button):
         self.net.send("build" , ["e1" ,self.selector.selobj ])    
   
        
        