

from OpenGL.GL import *

class Light:


    def __init__(self,ln,pos):
       ambient = [0.0, 0.0, 0.0, 1.0]
       diffuse = [1.0, 1.0, 1.0, 1.0]
       specular = [1.0, 1.0, 1.0, 1.0]
       position = [0.0, 3.0, 3.0, 0.0]
    
       lmodel_ambient = [0.2, 0.2, 0.2, 1.0]
       local_view = [0.0]
    
       ambient = [0.0, 0.0, 0.0, 1.0]
       diffuse = [1.0, 1.0, 1.0, 1.0]
       specular = [1.0, 1.0, 1.0, 1.0]
       position = [0.0, 3.0, 3.0, 0.0]
    
       lmodel_ambient = [0.2, 0.2, 0.2, 1.0]
       local_view = [0.0] 
    
       self.ln = ln
       self.pos = pos
    
       glLightfv(ln, GL_AMBIENT, ambient)
       glLightfv(ln, GL_DIFFUSE, diffuse)
       glLightfv(ln, GL_POSITION, pos)
       glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient)
       glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view)
    
       glFrontFace(GL_CW)
       glEnable(GL_LIGHTING)
       glEnable(ln)
       glEnable(GL_AUTO_NORMAL)
       glEnable(GL_NORMALIZE)
       glEnable(GL_DEPTH_TEST) 
       glEnable(GL_CULL_FACE)
       
       
    def Shine(self):
       glEnable(GL_LIGHTING)
       glEnable(self.ln)
       glLightfv(self.ln, GL_POSITION, self.pos) 
       
       
class Color:
    
    
    
    def __init__(self,r,g,b,a=1):
        self.c = [1,1,1,1]
        self.c[0] = r
        self.c[1] = g
        self.c[2] = b
        self.c[3] = a    
    
    def Bind(self):
        
        glColor4f( self.c[0],self.c[1],self.c[2],self.c[3] )
#
#class Material:
#
#
#    
#    #renderTeapot(14.0, 14.0, 0.0, 0.05, 0.05, 0.4, 0.5, 0.5,
#    #   0.04, 0.7, 0.7, .078125)
#    def __init__(self,ambr=14, ambg=14, ambb=14, difr=.05, difg=.05, 
#                      difb=.05, specr=.7, specg=.7, specb=.7, shine=.08):
#       
#       self.ambient  = Color( ambr ,  ambg, ambb, 1.0)
#       self.deffuse  = Color( difr ,  difg, difb)
#       self.specular = Color( specr, specg, specb)
#       self.shine    = shine * 128.0
#        
#    
#        
#    def Bind(self):
#        #, ambr, ambg, ambb, difr, difg, 
#        #              difb, specr, specg, specb, shine):
#              
#       glMaterialfv(GL_FRONT, GL_AMBIENT,  self.ambient.c)
#       glMaterialfv(GL_FRONT, GL_DIFFUSE, self.deffuse.c)
#       glMaterialfv(GL_FRONT, GL_SPECULAR, self.specular.c)
#       glMaterialf(GL_FRONT, GL_SHININESS, self.shine)
#      
      
def Normal(v0,v1,v2):
      
      a = [ v0[0] - v1[0], v0[1] - v1[1], v0[2] - v1[2] ]
      b = [ v1[0] - v2[0], v1[1] - v2[1], v1[2] - v2[2] ]
      c = [ a[1]*b[2] - b[1]*a[2], 
            b[0]*a[2] - a[0]*b[2],
            a[0]*b[1] - b[0]*a[1] ]

      glNormal3f( c[0] , c[1] , c[2] )   
      
        
    