
from pyTriD import *
 
 
class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable
 
class ColorMgmt:
 
    
    textures = {}
 
    def BindTexture(TextureName):
        """ gets the texture in"""
        try:
            ColorMgmt.textures[TextureName].Bind()
        except KeyError:
            ColorMgmt.textures[TextureName] = AlphaTexture("data/" + TextureName + ".png")
        
    BindTexture = Callable(BindTexture)    
        
    def SideColor(side):
        """ this is the side colors
            i might have this hook into data base later
        
        """
        if side == -1 :
            glColor4f(1,1,1,1)
            return
        
        color = [ (1,1,1),
          (0,0,1),
          (0,1,0),
          (0,1,1),
          (1,0,0),
          (1,0,1),
          (1,1,0),
          (1,1,1),
          (1,1,.5),
          (1,.5,1),
          (1,.5,.5),
          (.5,1,1),
          (.5,1,.5),
          (.5,.5,1),
          (.5,.5,.5),
          (0,0,.5),
          (0,.5,1),
          (0,.5,.5),
          (.5,0,0),
          (.5,0,.5),
          (.5,.5,0)]
          
        glColor3f(*color[side])
        
        
    SideColor = Callable(SideColor)    
       