 
 
from pyTriD import *
from ColorMgmt import ColorMgmt 
from math import *
from random import *


class Object:

    def __init__(self,id=0,x=0,y=0):
        self.x = x
        self.y = y
        self.r = 0
        self.id = id
    
    def Do(self,t,units):
        pass
    
    
    def Draw(self):
        pass
    
    def stats(self):
        return "x:" + str(self.x) + "y:" + str(self.x) + "id:" + str(self.id)

class UnitType:
    
    def __init__(self,name,):
        
        self.name = name
        
        self.speed     
        self.speedtype =  [ "gravanometric" , "shadowmatter" , "planoform" , "hypercomb" ]
        
        self.storige
        
        self.weapon
        self.weapontype = [ "laser" , "discharge" , "projectile" , "hypershread"]
        
        self.spesial = [ "cloke" , "hyperjump" , "timefreez" , "energyfunnel" ]
        
              

class Unit(Object):
    
    movealbe = False
    x = 0
    y = 0
    id = None
    r = 0
    
    def __init__(self,id=0,x=0,y=0,owner = 0, h = 100 ):
        self.x = x
        self.y = y
        self.r = 0
        self.h = h
        self.id = id
        self.Dist = 100
        self.gx = x    # go to post
        self.gy = y    
        self.at = None # who to torget
        
        self.energy = 0 # how much energy we have
    
        self.owner = owner
        self.type = 0
        
        
    def Move(self,t,speed):   
        
        Dist = ((self.x-self.gx)**2 + (self.y-self.gy)**2)**.5
        self.Dist = Dist
                
        if Dist > speed*t*1.1 :
            
            dx = (self.x-self.gx)/Dist
            dy = (self.y-self.gy)/Dist
            
            if dx == 0: 
                if dy > 0:
                    self.r = 90
                else:
                    self.r = 180
            else:
                
                self.r = atan(dy/dx)/3.1415926535897932384626433832795*180
                
                if dx < 0:
                    self.r += 180
            
            self.x -= dx*t*speed
            self.y -= dy*t*speed  

        else:
            
            self.x = self.gx
            self.y = self.gy
 
 
class Sprite(Unit):
 
    def Draw(self,gfx):  
        BindTexture( self.tex ) 
        #glTranslatef(3.0, 0.0, 0.0)
        # Draw a square (quadrilateral)
        #glColor4f(1, 1, 1 , 1)            # Bluish shade
        Color( self.own )  
        
        glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon
        glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0,  1.0)    # Bottom Left Of The Texture and Quad
        glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0,  1.0)    # Bottom Right Of The Texture and Quad
        glTexCoord2f(1.0, 1.0); glVertex3f( 1.0,  1.0,  1.0)    # Top Right Of The Texture and Quad
        glTexCoord2f(0.0, 1.0); glVertex3f(-1.0,  1.0,  1.0)    # Top Left Of The Texture and Quad
        glEnd()  
        
class Ansestor( Unit ):
    
    movealbe = True
    
    fn = "b1"
    
    def Do(self,t,units):
       
        self.Move(t,.2)
        self.War(t,units,20) 
       
    
       
    def War(self,t,units,hit):
        
        for unit2 in units.values():
                
            if unit2.owner != -1:
               if self.owner != unit2.owner:       
                
                Dist = ((self.x-unit2.x)**2 + (self.y-unit2.y)**2)**.5
             
                 
                if Dist < 2:
 
                    self.at = unit2.id
                    self.gx = self.x
                    self.gy = self.y    
                       
                    unit2.h -= t * uniform(0,hit)
                 
                elif Dist < 3:
                             
                    self.at = unit2.id
                    self.gx = unit2.x
                    self.gy = unit2.y    
                       
                    unit2.h -= t * uniform(0,hit*.6)
                    
                    #print "die! ", self.at 
                    
                        
#                 elif Dist < 6:
#                
#                    self.at = unit2.id
#                    self.gx = unit2.x
#                    self.gy = unit2.y
                   
            
                       

    def Draw(self):
        
        
        glScale(.5,.5,.2)
        ColorMgmt.BindTexture(self.fn)
        ColorMgmt.SideColor( self.owner )  
        DrawFlat()
        
        
        
        
        
class Dead(Unit):
    
    
    def Do(self, t,units):
        self.h -= t
    
    def Draw(self):
        
        
        ColorMgmt.BindTexture("dbr")
        glColor4f(1,1,1,self.h/30.)
        DrawStar()
        
class Fire(Dead):
    
    def Do(self,t,units):
       
        self.Move(t,1.5)
  
#        if self.Dist < t*.9 :
#            self.h = -1000
#    
        self.h -= t
    
    def Draw(self):
    
    
    
        glColor3f(1,1,1)
        ColorMgmt.BindTexture("spark")
        glColor3f(1,1,1)
        if self.Dist > .1 :
            glScalef(.1,.1,.1)
        
        glRotatef(self.h*360,1,0,1)
              
        DrawStar()
    
    
    
             

class Steam(Unit):       
       
    #def Do(self):
                       

    def Draw(self):
        
        glScale(4.5,4.5,.2)
        glColor(1,1,1)
        ColorMgmt.BindTexture("steam1")
        DrawFlat()  
        
class Wr(Ansestor):
     fn = "wr" 
     name = "Worker"
     def Do(self,t,units):
        self.Move(t,.4)
   
class B1(Ansestor):
    
     name = "Flyer"
     
     fn = "b1"
     def Do(self,t,units):
        self.Move(t,.5)
        self.War(t,units,20) 
      
class B2(Ansestor):
     name = "Killer"
     fn = "b2"
     def Do(self,t,units):
        self.Move(t,.6)
        self.War(t,units,40) 
      
   
       
class B3(Ansestor):
     name = "Thunder"
     fn = "b3"
     def Do(self,t,units):
        self.War(t,units,100) 
        self.Move(t,.5)
   
class Bulding(Unit):
    
    movealbe = False
   
    fn = "c1"
    
    def Do(self,t,units):
        pass
    
    
    def Draw(self):
        
        glScale(.5,.5,.2)
        ColorMgmt.BindTexture(self.fn)
        ColorMgmt.SideColor( self.owner )  
        DrawFlat()
        
        
   
class C1(Bulding):
     name = "Control"
     fn = "c1"
         
class C2(Bulding):
     name = "Command"
     fn = "c2"

class F1(Bulding):
     name = "Assembly"
     fn = "f1"
       
class F2(Bulding):
     name = "Factory"
     fn = "f2"

class E1(Bulding):
     name = "Steammer"
     fn = "e1"

        
               
 

     
   
        
         