

"""

    for py week 2 
    
    by Andre Von Houck


"""


# the imports
from socket import * 
import thread 
from time import sleep
import pack

import traceback 


class Server(object):
    
    
    #    messages [ " " , " " , ]
    #
    #
    def __init__(self,address,msgmap=[]):
        
        self.address = address
        self.p = pack.pack(msgmap)
        
                        
        self.bufferSize = 12000
        self.address = address
        ##print "creating node at",self.address
        self.sock = socket(AF_INET, SOCK_DGRAM)
        self.sock.bind(self.address)
        self.badaddress = None     
        thread.start_new_thread( self._run , ())

    def _run(self):   
    
        #print "running node"
        while True:
         try:
          
            newzipdata,self.fromaddress = self.sock.recvfrom(self.bufferSize)
            paket = self.p.zunpack(newzipdata)
            
            self._decode(paket)
         except :
             
             # do reset
             print "**************************reset"
             self.sock = socket(AF_INET, SOCK_DGRAM)
             self.sock.bind(self.address)
             
             print (newzipdata,self.fromaddress)
             self.badaddress = self.fromaddress
             traceback.print_exc()
       
       
    def _decode(self,paket):   
        
        if type(paket) != list or len(paket) != 2:
            return
        
        msg = paket[0]
        
        try:
        
            self.__getattribute__(msg)(paket[1])
        
        except AttributeError,e:
            print e
            #pass
            
        
        
    def send(self,msg,data):
       
     try:
        paket = [str(msg), data]
        zipdata = self.p.zpack (paket)
        return len(zipdata) == self.sock.sendto(zipdata, self.fromaddress)
     except:
          traceback.print_exc()
          return False
        
    def sendto(self,address, msg,data):
    
      try:
        paket = [str(msg), data]
        zipdata = self.p.zpack (paket)
        return len(zipdata) == self.sock.sendto(zipdata, address)
        
      except:
           traceback.print_exc()
           return False
    
    
    
    
    
    
class Client(object):

  
    #    messages [ " " , " " , ]
    #
    #
    def __init__(self,address,server,msgmap=[]):
        self.address = address
        self.p = pack.pack(msgmap)
        
        print gethostbyname(gethostname())
        self.bufferSize = 12000
        self.address = address
        ##print "creating node at",self.address
        self.sock = socket(AF_INET, SOCK_DGRAM)
        #self.sock.bind(self.address)
        self.sock.connect(server)
        
        self.server = server
        self.formaddress = ""
        thread.start_new_thread( self._run , ())

    def _run(self):   
        
        
        self.newzipdata = 0
        #print "running node"
        while True:
         try:
            self.newzipdata,self.formaddress = self.sock.recvfrom(self.bufferSize)
            #print "size" , len(newzipdata)
            paket = self.p.zunpack(self.newzipdata)
            
            self._decode(paket)
         except:
             print self.formaddress
             #print self.newzipdata
             traceback.print_exc()
       
       
    def _decode(self,paket):   
        
        
        if type(paket) != list or len(paket) != 2:
            print "bad paket" , paket
            print self.newzipdata
            return
        
        msg = paket[0]
        try:
            self.__getattribute__(msg)(paket[1])
        except AttributeError,e:
            print e
            pass
        
    def send(self,msg,data):
        
        
        try: 
            paket = [str(msg), data]
            zipdata = self.p.zpack (paket)
            self.sock.send(zipdata)
        except: 
            traceback.print_exc()
       

      
    
    
    
    
    