
import struct 
import zlib

"""

    for py week 2 
    
    by Andre Von Houck

    very cool altornative to pickle over network
    

"""

class pack:
    
   
    
    def __init__ (self, msgmap ):
        
        """
        cass map format
        
        
        """
        
        self.msgmap = msgmap
    
    def zpack(self,data):
        
        return zlib.compress(self.pack(data))
        
    def zunpack(self,data):
    
        return self.unpack( zlib.decompress(data) )
        
    
    def pack(self,data):
        
        if type(data) == str :
           # it is a simpe messege       
           for msgNumber,ent in enumerate(self.msgmap):
            if ent == data:
                 return 'n' +  struct.pack( "H" ,  msgNumber) 
            
           #raise data + " not defined in message map!"
           
           return 's' +  struct.pack( "H" ,  len(data)) + data 
            
        elif data == None :
       
           return 'z'
       
        elif data == True :
       
           return 't'
       
        elif data == False :
       
           return 'F'
         
  
        elif type(data) == int :
           # it is a simpe messege       
           return  'i' + struct.pack( "i" ,  data) 
     
        elif type(data) == float :
           # it is a simpe messege       
           return  'f' + struct.pack( "f" ,  data) 
   
        elif type(data) == list or type(data) == tuple :
           # it is a simpe messege       
           fulldata = 'l' +  struct.pack( "H" ,  len(data)) 
           for ent in data:
               fulldata += self.pack(ent)
           
           return fulldata
    
    
    
        else:
        
            classname = data.__class__ 
            #print classname 
            #print data.__dict__ 
           
            
            for clsNumber,ent in enumerate(self.msgmap):
             if type(ent) == list:
              if ent[0]  == classname:
                 fulldata = 'c' +  struct.pack( "H" , clsNumber )
                 dict = data.__dict__
                 for memb in ent[1:]:
                     value = dict[memb]
                     fulldata += self.pack(value)
                 
            
                 return fulldata
            
            
            raise str(data) + "class not defined in message map " 
        
       # else : raise str(type(data)) + " not allowed"
        
        
    def unpack(self,data):
    
      try:
        self._data = data
        self._pos  = 0
        return self._unpack()
      except:
      
        print "unpack error"
        #print data
        #print self._data[self._pos:]   
        
        
    def _unpackget2(self):
        
        self._pos += 2
        return self._data[self._pos-2:self._pos]
    
    def _unpackget4(self):
        
        self._pos += 4
        return self._data[self._pos-4:self._pos]
        
            
    def _unpack(self):
        
        c = self._data[self._pos]
        self._pos+=1
        
        if c == 'n':
            #name
            msgNumber = struct.unpack ( "H" ,  self._unpackget2() )[0]
            
            return self.msgmap[msgNumber]
       
        if c == 'z':
            return None
       
        if c == 't':
            return True
     
        if c == 'F':
            return False
       
        
        elif c == 'i':
            #name
            number = struct.unpack ( "i" ,   self._unpackget4() )[0]
            return number
        
        elif c == 'f':
            #name
            number = struct.unpack ( "f" ,   self._unpackget4() )[0]
            return number
    
        elif c == 'l':
            #name
            len = struct.unpack ( "H" ,   self._unpackget2() )[0]
            list = []
            for ent in range(len):
                list.append(self._unpack())
            
            return list


        elif c == 'c':
            #name
            clsNumber = struct.unpack ( "H" ,   self._unpackget2() )[0]
            ent = self.msgmap[clsNumber]
            try:
                cls = ent[0]()
            except TypeError:
                print "class " , ent , " must have a no argument constructor"
            
            for memb in ent[1:]:
                cls .__dict__ [ memb ]  = self._unpack()
            
            return cls

        elif c == 's':
            #name
            strLen = struct.unpack ( "H" ,   self._unpackget2() )[0]
            str = self._data[self._pos:self._pos+strLen]
            self._pos+=strLen
       
            return str

        else:
        
             print "unpack error encode " + c
             print data
             print self._data[self._pos:]   
        
