
from pygame.mixer import *

init(22050, -16, True, 1024)


def play( file ):
    
    music.load ( file ) # - Load a music file for playback    Load a music file for playback
    music.play () # - Start the playback of the music stream    Start the playback of the music stream



class Sounds:
    
    
    def __init__(self):
        self.sounds = {}
    
    def play( self, file , v=.5 ):
        
        try:
            self.sounds[file].play()
        except KeyError:
            self.sounds[file] = Sound(file)
            self.sounds[file].play()
            self.sounds[file].set_volume(v)
            
        
    
    
    
    
    
    



