



from OpenGL.GL import *





class Vec:
    
    #x,y,z
    
    def __init__(self,v):
        self.x = v[0]
        self.y = v[1]
        self.z = v[2]
        
        
    def Use(self):
        glTranslatef(self.x,self.y,self.z)
        
    def Draw(self):
        glVertex3f(self.x,self.y,self.z)
        
    def Dot(self,v):
        return self.x*v.x + self.y*v.y + self.z*v.z
    
    def __mul__(self,v):
        return Vec([self.x*v , self.y*v , self.z*v])
    def __div__(self,v):
        return Vec([self.x/v , self.y/v , self.z/v])
    
    def __add__(self,v): 
        return Vec([self.x+v.x,self.y+v.y,self.z+v.z])
    
    def __sub__(self,v): 
        return Vec([self.x-v.x,self.y-v.y,self.z-v.z])
   
    def __str__(self):
        return str((self.x,self.y,self.z))
        
    def Mag(self):
        return (self.x**2+self.y**2+self.z**2)**.5
 
    def toLine(P0,P1,P2): 
        
        DimLINE=abs((P1.x-P2.x)**2+ 
           (P1.y-P2.y)**2+ 
           (P1.z-P2.z)**2)**0.5 
        
        if DimLINE>0: 
           Ratio=((P0.x-P1.x)*(P2.x-P1.x) + 
                  (P0.y-P1.y)*(P2.y-P1.y) +  
                  (P0.z-P1.z)*(P2.z-P1.z))/DimLINE**2 
           P4=[0.0,.0,.0]  
           P4.x = P1.x + Ratio*(P2.x-P1.x) 
           P4.y = P1.y + Ratio*(P2.y-P1.y) 
           P4.z = P1.z + Ratio*(P2.z-P1.z) 
           MinDIST=abs((P4.x-P0.x)**2+ 
                  (P4.y-P0.y)**2+ 
                  (P4.z-P0.z)**2)**0.5 
        elif  DimLINE==0 : 
            MinDIST=abs((P1.x-P0.x)**2+ 
                 (P1.y-P0.y)**2+ 
                 (P1.z-P0.z)**2)**0.5 
        return MinDIST 
    
    
    
    
    
    